#include <stdio.h>

#define	UNKNOWN		0x47001
#define	ENTER		0x47002
#define	COLOR		0x47003
#define	TRIANGLE	0x47004
#define	SPANISH		0x47005

#define	BLOCKSIZE	32

typedef struct ascii_array_st* ascii_array;

struct ascii_array_st{
	int address;
	int *array;	
	int csize;
	int size;
	int invalid;
};

ascii_array new_ascii();
void print_ascii(ascii_array text);
ascii_array insert_ascii(int value, ascii_array text);
void fprint_ascii(FILE *file, ascii_array text);
ascii_array free_ascii(ascii_array text);
ascii_array setaddress(int address, ascii_array text);

ascii_array grow_ascii(ascii_array text);

