#ifndef STDIO_H
  #define STDIO_H
  #include <stdio.h>
#endif

#include "list_text.h"

l_text new_text()
{
   	return((l_text)NULL);
}

l_text insert_text(ascii_array text, l_text list)
{
   	l_text adv, n_text, ant;
	l_text exists;

   	adv = list;
   	exists = exists_text(text, list);
   	if(exists)
		return(list);
   	if(!(n_text = (l_text)malloc(sizeof(struct l_text_st))))
   	{
     		printf("No memory available\n");
     		exit(1);
   	}
   	n_text->text = text;
   	n_text->next = (l_text)NULL;
	if(!list)
		return(n_text);
	if(list->text->address > text->address)
	{
		n_text->next = list;
		return(n_text);
	}
	ant = new_text();
	while(adv)
	{
		if(adv->text->address > text->address)
		{
			l_text tmp;
			
			tmp = ant->next;
			ant->next = n_text;
			n_text->next = tmp;
			return(list);
		}
		else
		{
			ant = adv;
			adv = adv->next;
		}
	}
	ant->next = n_text;
	print_ascii(text);
   	return(list);
}

int texts_length(l_text list)
{
	int len = 0;
   	while(list)
   	{
		len ++;
		list = list->next;
   	}
	return(len);
}

void print_texts(l_text list, FILE *file)
{
   	while(list)
   	{
		fprint_ascii(file, list->text);
		list = list->next;
   	}
}

l_text exists_text(ascii_array text, l_text list)
{
   	while(list)
   	{
		if(text->csize == list->text->csize)
		{
			int count = 0;
			int i;
			
			for(i = 0; i < text->csize; i++)
			{
				if(list->text->array[i] == text->array[i])
					count ++;
				else
					break;
			}
			if(text->csize == count)
				return(list);
		}
		list = list->next;
   	}
   	return(NULL);
}

l_text free_texts(l_text list)
{
   	l_text tmp;

   	while(list)
   	{
      		tmp = list->next;
      		free_ascii(list->text);
      		free(list);
      		list = tmp;
   	} 
   	return((l_text)NULL);
}
